SLASH_LOOK1 = "/look"
local tarPlateBTN = nil
local nameplateCounter = 0
local selectedPlate = 1
local nameplateSetting = 0

local __, addon = ...
local speakText = addon.speakText
local speakTextIfQuiet = addon.speakTextIfQuiet

local checkDistance=1

local frame = CreateFrame("Frame")
frame:RegisterEvent("NAME_PLATE_UNIT_ADDED")
frame:RegisterEvent("NAME_PLATE_UNIT_REMOVED")
frame:SetScript("OnEvent", function(self, event, arg1)
    if event == "NAME_PLATE_UNIT_ADDED" then
nameplateCounter=nameplateCounter+1
if(nameplateSetting==0) then
if(UnitIsEnemy("player",arg1)) then
                      PlaySoundFile("Interface/AddOns/WOWAccess/sounds/nameplateisenemy.ogg")
 else
               PlaySoundFile("Interface/AddOns/WOWAccess/sounds/nameplateadded.ogg")
end
if(UnitIsUnit(arg1, "target")) then
                      PlaySoundFile("Interface/AddOns/WOWAccess/sounds/nameplateistarget.ogg") 
end
elseif(nameplateSetting==1) then
if(UnitIsEnemy("player",arg1)) then
                      PlaySoundFile("Interface/AddOns/WOWAccess/sounds/nameplateisenemy.ogg")
end
if(UnitIsUnit(arg1, "target")) then
                      PlaySoundFile("Interface/AddOns/WOWAccess/sounds/nameplateistarget.ogg") 
end

elseif(nameplateSetting==2) then
if(UnitIsUnit(arg1, "target")) then
                      PlaySoundFile("Interface/AddOns/WOWAccess/sounds/nameplateistarget.ogg") 
end

end
    elseif event == "NAME_PLATE_UNIT_REMOVED" then
nameplateCounter=nameplateCounter-1
if(UnitIsUnit(arg1, "target")) then
                      PlaySoundFile("Interface/AddOns/WOWAccess/sounds/nameplateistargetremoved.ogg") 
end
if(nameplateSetting==0) then
if(UnitIsEnemy("player",arg1)) then
                      PlaySoundFile("Interface/AddOns/WOWAccess/sounds/nameplateremoved.ogg") 
 else
                      PlaySoundFile("Interface/AddOns/WOWAccess/sounds/nameplateremoved.ogg") 
end
elseif(nameplateSetting==1) then
if(UnitIsEnemy("player",arg1)) then
                      PlaySoundFile("Interface/AddOns/WOWAccess/sounds/nameplateremoved.ogg") 
end
end
    end
end)
local MAX_NAME_PLATE_UNITS = 40
local function look()
for i = 1, MAX_NAME_PLATE_UNITS do
    local unit = "nameplate" .. i
    local name = UnitName(unit)

    if name then
        C_VoiceChat.SpeakText(0, name, 4, 0, 100)
    end
end
end

local function readSelectedNameplate()
if(selectedPlate<1) then
selectedPlate=1
end
if(selectedPlate==nil and nameplateCounter>0) then
selectedPlate=1
end
if(selectedPlate>nameplateCounter) then
selectedPlate=nameplateCounter
end
if(nameplateCounter>0) then

local unit = "nameplate"..selectedPlate
speakText(UnitName(unit))
if(nameplateSetting==0) then
if(UnitIsEnemy("player",unit)) then
                      PlaySoundFile("Interface/AddOns/WOWAccess/sounds/nameplateisenemy.ogg")
 else
               PlaySoundFile("Interface/AddOns/WOWAccess/sounds/nameplateadded.ogg")
end
if(UnitIsUnit(unit, "target")) then
                      PlaySoundFile("Interface/AddOns/WOWAccess/sounds/nameplateistarget.ogg") 
end
elseif(nameplateSetting==1) then
if(UnitIsEnemy("player",unit)) then
                      PlaySoundFile("Interface/AddOns/WOWAccess/sounds/nameplateisenemy.ogg")
end
if(UnitIsUnit(unit, "target")) then
                      PlaySoundFile("Interface/AddOns/WOWAccess/sounds/nameplateistarget.ogg") 
end
elseif(nameplateSetting==2) then
if(UnitIsUnit(unit, "target")) then
                      PlaySoundFile("Interface/AddOns/WOWAccess/sounds/nameplateistarget.ogg") 
end

end

if(not InCombatLockdown()) then
tarPlateBTN:SetAttribute("macrotext", "/target "..UnitName(unit))
end
end
end

local function SelectNextPlate()
selectedPlate=selectedPlate+1
readSelectedNameplate()
end

local function SelectPrevPlate()
selectedPlate=selectedPlate-1
readSelectedNameplate()
end
local function updateSelectedPlate()
if(selectedPlate==nil and nameplateCounter>0) then
selectedPlate=1
end
if(selectedPlate>nameplateCounter) then
selectedPlate=nameplateCounter
end
if(selectedPlate<1) then
selectedPlate = 1
end
C_Timer.After(.25, updateSelectedPlate)
end
local targetInteractable= 0
local function checkTargetDistance()
if(checkDistance==1 and UnitExists("target")) then
local dist = CheckInteractDistance("target", 3)
if(dist) then
if(targetInteractable==0) then
               PlaySoundFile("Interface/AddOns/WOWAccess/sounds/targetisinteractablerange.ogg")
targetInteractable=1
end

elseif(targetInteractable==1) then
               PlaySoundFile("Interface/AddOns/WOWAccess/sounds/targetisnotinteractablerange.ogg")
targetInteractable=0
end
end
C_Timer.After(.25, checkTargetDistance)
end


local EventFrame = CreateFrame("frame", "EventFrame")
EventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")

EventFrame:SetScript("OnEvent", function(self, event, ...)
	if(event == "PLAYER_ENTERING_WORLD") then
C_Timer.After(1, function() 
checkTargetDistance()
updateSelectedPlate()
local btn = CreateFrame("BUTTON", "Look")
SetBindingClick("ALT-L", "Look")
btn:SetScript("OnClick", function(self, BUTTON, down)
look()
end)
local btn = CreateFrame("BUTTON", "ReadSelectedPlate")
SetBindingClick("ALT-'", "ReadSelectedPlate")
btn:SetScript("OnClick", function(self, BUTTON, down)
readSelectedNameplate()
end)
local btn = CreateFrame("BUTTON", "ReadNextSelectedPlate")
SetBindingClick("ALT-]", "ReadNextSelectedPlate")
btn:SetScript("OnClick", function(self, BUTTON, down)
SelectNextPlate()
--speakText("next plate success.")
end)
local btn = CreateFrame("BUTTON", "ReadPrevSelectedPlate")
SetBindingClick("ALT-[", "ReadPrevSelectedPlate")
btn:SetScript("OnClick", function(self, BUTTON, down)
SelectPrevPlate()
--speakText("prev plate success.")
end)

tarPlateBTN = CreateFrame("Button", "TargetNameplate", nil, "SecureActionButtonTemplate")
SetBindingClick("ALT-ENTER", "TargetNameplate")
tarPlateBTN:SetAttribute("type", "macro")

local btn = CreateFrame("BUTTON", "TargetDistance")
SetBindingClick("ALT-I", "TargetDistance")
btn:SetScript("OnClick", function(self, BUTTON, down)
if(checkDistance==0) then
checkDistance=1
speakText("Target Interact Alert On")
else
checkDistance=0
speakText("Target Interact alert off")
end
end)

local btn = CreateFrame("BUTTON", "NameplateSetting")
SetBindingClick("ALT-U", "NameplateSetting")
btn:SetScript("OnClick", function(self, BUTTON, down)
nameplateSetting = nameplateSetting+1

if(nameplateSetting==3) then
nameplateSetting=0
end
if(nameplateSetting==0) then
speakText("Nameplate alerts set to all")
elseif(nameplateSetting==1) then
speakText("Nameplate alert set to hostiles and target")
elseif(nameplateSetting==2) then
speakText("Nameplate alert set to target only")
end

end)


end)
end
end)

SlashCmdList["LOOK"] = look;